diff --git a/src/main/java/net/minecraft/core/block/SpikesBlock.java b/src/main/java/net/minecraft/core/block/SpikesBlock.java
index 9e80c1cfd..29239e24c 100644
--- a/src/main/java/net/minecraft/core/block/SpikesBlock.java
+++ b/src/main/java/net/minecraft/core/block/SpikesBlock.java
@@ -7,18 +7,14 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.WorldSource;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, Entity, Item,
-//            World, AxisAlignedBB
-
-//TODO make it not extend blockWeb
-public class SpikesBlock extends CobwebBlock
+public class SpikesBlock extends Block
 {
 
     public SpikesBlock(String key, String namespaceId, int id, Material mat)
@@ -26,6 +22,18 @@ public class SpikesBlock extends CobwebBlock
         super(key, namespaceId, id, mat);
     }
 
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        if (world.isClientSide) {
+            return;
+        }
+
+        int meta = world.getBlockMetadata(x, y, z);
+        if(world.hasNeighborSignal(x, y, z)) {
+            world.setBlockMetadataWithNotify(x, y, z, meta | 1);
+        }
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
@@ -53,7 +61,7 @@ public class SpikesBlock extends CobwebBlock
 
 		int meta = world.getBlockMetadata(x, y, z);
 		boolean wasPowered = (meta & 1) > 0;
-		boolean isPowered = world.isBlockIndirectlyGettingPowered(x, y, z);
+		boolean isPowered = world.hasNeighborSignal(x, y, z);
 		
 		if(isPowered != wasPowered) {
 			if(isPowered) {
@@ -98,4 +106,14 @@ public class SpikesBlock extends CobwebBlock
     {
         return (i & 1) != 1;
     }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/StillFluidBlock.java b/src/main/java/net/minecraft/core/block/StillFluidBlock.java
index 3b8b57696..309865dcf 100644
--- a/src/main/java/net/minecraft/core/block/StillFluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/StillFluidBlock.java
@@ -32,11 +32,11 @@ public class StillFluidBlock extends FluidBlock
     private void setFlowing(World world, int i, int j, int k)
     {
         int l = world.getBlockMetadata(i, j, k);
-        world.editingBlocks = true;
+        world.noNeighborUpdate = true;
         world.setBlockAndMetadata(i, j, k, id - 1, l);
         world.markBlocksDirty(i, j, k, i, j, k);
         world.scheduleBlockUpdate(i, j, k, id - 1, tickDelay());
-        world.editingBlocks = false;
+        world.noNeighborUpdate = false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/TNTBlock.java b/src/main/java/net/minecraft/core/block/TNTBlock.java
index 28509f42d..afc651056 100644
--- a/src/main/java/net/minecraft/core/block/TNTBlock.java
+++ b/src/main/java/net/minecraft/core/block/TNTBlock.java
@@ -19,14 +19,14 @@ public class TNTBlock extends Block {
 	@Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
 		super.onBlockPlacedByWorld(world, x, y, z);
-		if (world.isBlockIndirectlyGettingPowered(x, y, z)) {
+		if (world.hasNeighborSignal(x, y, z)) {
 			ignite(world, x, y, z, true);
 		}
 	}
 
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-		if (blockId > 0 && Block.blocksList[blockId].isSignalSource() && world.isBlockIndirectlyGettingPowered(x, y, z)) {
+		if (blockId > 0 && Block.blocksList[blockId].isSignalSource() && world.hasNeighborSignal(x, y, z)) {
 			ignite(world, x, y, z, true);
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
index fcd92ecca..be570f0d0 100644
--- a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.Item;
@@ -18,94 +19,89 @@ import net.minecraft.core.world.WorldSource;
 //            Block, Material, IBlockAccess, World, 
 //            AxisAlignedBB, Player, Vec3D, MovingObjectPosition
 
-public class TrapDoorBlock extends Block
-{
-
-	
-	private boolean isIron;
-	
-	public TrapDoorBlock(String key, String namespaceId, int id, Material material, boolean isIron)
-    {
+public class TrapDoorBlock extends Block {
+    public TrapDoorBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
         float f = 0.5F;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
-        this.isIron = isIron;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        super.onBlockPlacedByMob(world, x, y, z, side, mob, sideHeight);
+
+        int meta = world.getBlockMetadata(x, y, z);
+        final boolean isPowered = world.hasNeighborSignal(x, y, z);
+
+        if (isPowered) {
+            meta = setTrapdoorPowered(meta, true);
+            meta = setTrapdoorOpen(meta, true);
+            world.setBlockMetadataWithNotify(x, y, z, setTrapdoorPowered(meta, true));
+        }
+    }
+
+    @Override
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.getSelectedBoundingBoxFromPool(world, x, y, z);
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.getCollisionBoundingBoxFromPool(world, x, y, z);
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
         setBlockBoundsForBlockRender(world.getBlockMetadata(x, y, z));
     }
 
-    public void setBlockBoundsForBlockRender(int i)
-    {
+    public void setBlockBoundsForBlockRender(int i) {
         float f = 0.1875F;
-        
-        if(isTrapdoorOpen(i))
-        {
-            if((i & 3) == 0)
-            {
+
+        if (isTrapdoorOpen(i)) {
+            if ((i & 3) == 0) {
                 setBlockBounds(0.0F, 0.0F, 1.0F - f, 1.0F, 1.0F, 1.0F);
             }
-            if((i & 3) == 1)
-            {
+            if ((i & 3) == 1) {
                 setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, f);
             }
-            if((i & 3) == 2)
-            {
+            if ((i & 3) == 2) {
                 setBlockBounds(1.0F - f, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
             }
-            if((i & 3) == 3)
-            {
+            if ((i & 3) == 3) {
                 setBlockBounds(0.0F, 0.0F, 0.0F, f, 1.0F, 1.0F);
             }
-        }else {
-        	if(isUpperHalf(i)) {
+        } else {
+            if (isUpperHalf(i)) {
                 setBlockBounds(0.0F, 1.0f - f, 0.0F, 1.0F, 1.0f, 1.0F);
-        	}else {
+            } else {
                 setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
-        	}
+            }
         }
     }
-    
+
     @Override
     public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
-    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
-    		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
-    	}
+        if (!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
+            onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
+        }
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
-    {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
         if (blockMaterial != Material.metal) {
             int l = world.getBlockMetadata(x, y, z);
             world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
@@ -115,76 +111,107 @@ public class TrapDoorBlock extends Block
         return false;
     }
 
-	@Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-		if(world.isClientSide) {
-			return;
-		}
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if (world.isClientSide) {
+            return;
+        }
 
-		if(isIron || blockId > 0 && Block.getBlock(blockId).isSignalSource()) {
-			int meta = world.getBlockMetadata(x, y, z);
-			boolean isOpened = isTrapdoorOpen(meta);
-			boolean isPowered = world.isBlockIndirectlyGettingPowered(x, y, z);
+        int meta = world.getBlockMetadata(x, y, z);
+        final boolean wasPowered = isTrapdoorPowered(meta);
+        final boolean isPowered = world.hasNeighborSignal(x, y, z);
 
-			if(isOpened != isPowered) {
-				world.setBlockMetadataWithNotify(x, y, z, meta ^ 4);
-				world.playSoundEffect(null, 1003, x, y, z, 0);
-			}
-		}
-	}
+        if (wasPowered != isPowered) {
+            if (isPowered != isTrapdoorOpen(meta)) {
+                world.playSoundEffect(null, 1003, x, y, z, 0);
+            }
+            meta = setTrapdoorPowered(meta, isPowered);
+            meta = setTrapdoorOpen(meta, isPowered);
+            world.setBlockMetadataWithNotify(x, y, z, setTrapdoorPowered(meta, isPowered));
+        }
+    }
 
     @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
-    {
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end) {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.collisionRayTrace(world, x, y, z, start, end);
     }
-    
+
     @Override
     public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
-    	int meta = getMetaForDirection(player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
-    	if(player.getVerticalPlacementDirection(side, yPlaced) == Direction.UP) {
-    		meta |= 8;
-    	}
-    	return meta;
+        int meta = getMetaForDirection(player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
+        if (player.getVerticalPlacementDirection(side, yPlaced) == Direction.UP) {
+            meta = setUpperHalf(meta, true);
+        }
+        return meta;
     }
-    
+
     @Override
     public boolean isClimbable(World world, int x, int y, int z) {
-    	Block block = world.getBlock(x, y - 1, z);
-    	int meta = world.getBlockMetadata(x, y, z);
-    	if(isTrapdoorOpen(meta) && block instanceof LadderBlock) {
-    		LadderBlock ladder = (LadderBlock) block;
-    		Side ladderSide = ladder.getSideFromMeta(world.getBlockMetadata(x, y - 1, z));
-    		Direction trapdoorDirection = getDirectionForMeta(meta);
-    		return ladderSide.getDirection().getOpposite() == trapdoorDirection;
-    	}
-    	return false;
-    }
-    
-    public static boolean isTrapdoorOpen(int metadata)
-    {
-        return (metadata & 4) != 0;
-    }
-    
+        Block block = world.getBlock(x, y - 1, z);
+        int meta = world.getBlockMetadata(x, y, z);
+        if (isTrapdoorOpen(meta) && block instanceof LadderBlock) {
+            LadderBlock ladder = (LadderBlock) block;
+            Side ladderSide = ladder.getSideFromMeta(world.getBlockMetadata(x, y - 1, z));
+            Direction trapdoorDirection = getDirectionForMeta(meta);
+            return ladderSide.getDirection().getOpposite() == trapdoorDirection;
+        }
+        return false;
+    }
+
+    public static boolean isTrapdoorOpen(int metadata) {
+        return (metadata & 0b0000_0100) != 0;
+    }
+
+    public static int setTrapdoorOpen(int metadata, boolean isOpen) {
+        if (isOpen) {
+            metadata |= 0b0000_0100;
+        } else {
+            metadata &= 0b1111_1011;
+        }
+        return metadata;
+    }
+
+    public static boolean isTrapdoorPowered(int metadata) {
+        return (metadata & 0b0001_0000) != 0;
+    }
+
+    public static int setTrapdoorPowered(int metadata, boolean isPowered) {
+        if (isPowered) {
+            metadata |= 0b0001_0000;
+        } else {
+            metadata &= 0b1110_1111;
+        }
+        return metadata;
+    }
+
     public static boolean isUpperHalf(int meta) {
-    	return (meta & 8) != 0;
+        return (meta & 8) != 0;
     }
-    
+
+    public static int setUpperHalf(int metadata, boolean isUpperHalf) {
+        if (isUpperHalf) {
+            metadata |= 0b0000_1000;
+        } else {
+            metadata &= 0b1111_0111;
+        }
+        return metadata;
+    }
+
     public int getMetaForDirection(Direction dir) {
-    	if(dir == Direction.NORTH) return 1;
-    	if(dir == Direction.EAST) return 2;
-    	if(dir == Direction.SOUTH) return 0;
-    	if(dir == Direction.WEST) return 3;
-    	return 0;
-    }
-    
-    public Direction getDirectionForMeta(int meta) {
-    	meta = meta & 3;
-    	if(meta == 0) return Direction.SOUTH;
-    	if(meta == 1) return Direction.NORTH;
-    	if(meta == 2) return Direction.EAST;
-    	if(meta == 3) return Direction.WEST;
-    	return Direction.NONE;
+        if (dir == Direction.NORTH) return 1;
+        if (dir == Direction.EAST) return 2;
+        if (dir == Direction.SOUTH) return 0;
+        if (dir == Direction.WEST) return 3;
+        return 0;
+    }
+
+    public Direction getDirectionForMeta(int metadata) {
+        metadata = metadata & 3;
+        if (metadata == 0) return Direction.SOUTH;
+        if (metadata == 1) return Direction.NORTH;
+        if (metadata == 2) return Direction.EAST;
+        if (metadata == 3) return Direction.WEST;
+        return Direction.NONE;
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/TrommelBlock.java b/src/main/java/net/minecraft/core/block/TrommelBlock.java
index 2df0d5901..a6f320407 100644
--- a/src/main/java/net/minecraft/core/block/TrommelBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrommelBlock.java
@@ -22,7 +22,6 @@ public class TrommelBlock extends RotatableEntityBlock
     {
         super(key, namespaceId, id, material);
         this.isActive = isActive;
-        random = new Random();
     }
 
     @Override
@@ -68,72 +67,31 @@ public class TrommelBlock extends RotatableEntityBlock
         world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
     }
     
-    public static void updateTrommelBlockState(boolean flag, World world, int i, int j, int k)
+    public static void updateTrommelBlockState(boolean lit, World world, int x, int y, int z)
     {
-        int l = world.getBlockMetadata(i, j, k);
-        BlockEntity blockEntity = world.getBlockEntity(i, j, k);
+        int l = world.getBlockMetadata(x, y, z);
+        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
         if(blockEntity == null) {
-            String msg = "Trommel is missing Tile Entity at x: " + i + " y: " + j + " z: " + k + ", block will be removed!";
+            String msg = "Trommel is missing Tile Entity at x: " + x + " y: " + y + " z: " + z + ", block will be removed!";
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
             }
-            world.setBlockWithNotify(i, j, k, 0);
+            world.setBlockWithNotify(x, y, z, 0);
             LOGGER.warn(msg);
             return;
         }
         keepTrommelInventory = true;
-        if(flag)
+        if(lit)
         {
-            world.setBlockWithNotify(i, j, k, Blocks.TROMMEL_ACTIVE.id);
+            world.setBlockWithNotify(x, y, z, Blocks.TROMMEL_ACTIVE.id);
         } else
         {
-            world.setBlockWithNotify(i, j, k, Blocks.TROMMEL_IDLE.id);
+            world.setBlockWithNotify(x, y, z, Blocks.TROMMEL_IDLE.id);
         }
         keepTrommelInventory = false;
-        world.setBlockMetadataWithNotify(i, j, k, l);
+        world.setBlockMetadataWithNotify(x, y, z, l);
         blockEntity.validate();
-        world.setBlockTileEntity(i, j, k, blockEntity);
-    }
-    
-    @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
-    	if (!keepTrommelInventory)
-    	{
-    		if(world.getBlockEntity(x, y, z) != null)
-    		{
-    			TrommelBlockEntity trommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
-    			label0:
-				for (int l = 0; l < trommel.getContainerSize(); l++)
-				{
-					ItemStack itemstack = trommel.getItem(l);
-					if (itemstack == null) {
-						continue;
-					}
-					float f = random.nextFloat() * 0.8F + 0.1F;
-					float f1 = random.nextFloat() * 0.8F + 0.1F;
-					float f2 = random.nextFloat() * 0.8F + 0.1F;
-					do {
-						if (itemstack.stackSize <= 0) {
-							continue label0;
-						}
-						int i1 = random.nextInt(21) + 10;
-						if (i1 > itemstack.stackSize) {
-							i1 = itemstack.stackSize;
-						}
-						itemstack.stackSize -= i1;
-						ItemEntity item = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
-						float f3 = 0.05F;
-						item.xd = (float) random.nextGaussian() * f3;
-						item.yd = (float) random.nextGaussian() * f3 + 0.2F;
-						item.zd = (float) random.nextGaussian() * f3;
-						world.entityJoinedWorld(item);
-					} while (true);
-				}
-    		}
-    	}
-
-        super.onBlockRemoved(world, x, y, z, data);
+        world.setBlockTileEntity(x, y, z, blockEntity);
     }
 
 
@@ -144,6 +102,5 @@ public class TrommelBlock extends RotatableEntityBlock
     }
 
     private boolean isActive;
-    protected static boolean keepTrommelInventory = false;
-    private Random random;
+    public static boolean keepTrommelInventory = false;
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
index 0f92e779d..5d0c24185 100644
--- a/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
@@ -20,31 +20,6 @@ public class BasketBlockEntity extends BlockEntity
     private int numUnitsInside = 0;
     private final Map<BasketEntry, Integer> contents = new HashMap<>();
 
-    public void dropAllItems()
-    {
-        final Random rand = new Random();
-
-        for (Map.Entry<BasketEntry, Integer> entry : contents.entrySet())
-        {
-            BasketEntry be = entry.getKey();
-            int numItems = entry.getValue();
-
-            while (numItems > 0)
-            {
-                int maxStackSize = be.getItem().getItemStackLimit();
-                int stackSize = maxStackSize;
-                int remainingItems = numItems - maxStackSize;
-                if (remainingItems < 0) stackSize = numItems;
-                numItems -= stackSize;
-                dropItemStack(rand, new ItemStack(be.id, stackSize, be.metadata, be.tag));
-            }
-        }
-
-        contents.clear();
-
-        worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
-        updateNumUnits();
-    }
 
     private void updateNumUnits()
     {
@@ -76,12 +51,21 @@ public class BasketBlockEntity extends BlockEntity
         final float f1 = rand.nextFloat() * 0.8F + 0.1F;
         final float f2 = rand.nextFloat() * 0.8F + 0.1F;
 
-        final ItemEntity entityitem = new ItemEntity(worldObj, x + f, y + f1, z + f2, itemstack);
+        World workingWorld;
+        if (worldObj != null) {
+            workingWorld = worldObj;
+        } else if (carriedBlock != null) {
+            workingWorld = carriedBlock.world;
+        } else {
+            return;
+        }
+
+        final ItemEntity item = new ItemEntity(workingWorld, x + f, y + f1, z + f2, itemstack);
         final float f3 = 0.05F;
-        entityitem.xd = (float) rand.nextGaussian() * f3;
-        entityitem.yd = (float) rand.nextGaussian() * f3 + 0.25F;
-        entityitem.zd = (float) rand.nextGaussian() * f3;
-        worldObj.entityJoinedWorld(entityitem);
+        item.xd = (float) rand.nextGaussian() * f3;
+        item.yd = (float) rand.nextGaussian() * f3 + 0.25F;
+        item.zd = (float) rand.nextGaussian() * f3;
+        workingWorld.entityJoinedWorld(item);
     }
 
     public int getNumUnitsInside()
@@ -115,7 +99,7 @@ public class BasketBlockEntity extends BlockEntity
 		}
 
 		updateNumUnits();
-		worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+        world.notifyBlockChange(x, y, z, Blocks.BASKET.id);
 	}
 
     @Override
@@ -137,15 +121,32 @@ public class BasketBlockEntity extends BlockEntity
     @Override
     public void tick()
     {
-        if (worldObj == null || worldObj.isClientSide) return;
+        if (worldObj != null && worldObj.isClientSide) return;
+        if (carriedBlock != null && carriedBlock.world.isClientSide) return;
+
+        double posX, posY, posZ;
+        World workingWorld;
+        if (worldObj != null) {
+            workingWorld = worldObj;
+            posX = x;
+            posY = y;
+            posZ = z;
+        } else if (carriedBlock != null) {
+            workingWorld = carriedBlock.world;
+            posX = carriedBlock.holder.x - 0.5;
+            posY = carriedBlock.holder.y - carriedBlock.holder.heightOffset;
+            posZ = carriedBlock.holder.z - 0.5;
+        } else {
+            return;
+        }
 
-        final AABB aabb = AABB.getTemporaryBB(x, y, z, x + 1, y + 2, z + 1);
+        final AABB aabb = AABB.getTemporaryBB(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
 
-        final List<Entity> entities = worldObj.getEntitiesWithinAABB(ItemEntity.class, aabb);
+        final List<Entity> entities = workingWorld.getEntitiesWithinAABB(ItemEntity.class, aabb);
 
         boolean shouldUpdate = false;
 
-        if (entities.size() > 0)
+        if (!entities.isEmpty())
         {
             for (final Entity e : entities)
             {
@@ -164,7 +165,9 @@ public class BasketBlockEntity extends BlockEntity
 
         if (shouldUpdate)
         {
-            worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+            if (worldObj != null) {
+                worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+            }
             updateNumUnits();
         }
     }
@@ -204,6 +207,42 @@ public class BasketBlockEntity extends BlockEntity
         return new BlockEntityDataPacket(this);
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        final Random rand = new Random();
+
+        for (Map.Entry<BasketEntry, Integer> entry : contents.entrySet())
+        {
+            BasketEntry be = entry.getKey();
+            int numItems = entry.getValue();
+
+            while (numItems > 0)
+            {
+                int maxStackSize = be.getItem().getItemStackLimit();
+                int stackSize = maxStackSize;
+                int remainingItems = numItems - maxStackSize;
+                if (remainingItems < 0) stackSize = numItems;
+                numItems -= stackSize;
+                dropItemStack(rand, new ItemStack(be.id, stackSize, be.metadata, be.tag));
+            }
+        }
+
+        contents.clear();
+
+        world.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+        updateNumUnits();
+    }
+
+    @Override
+    public void heldTick(World world, Entity holder) {
+        tick();
+    }
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
     private static final class BasketEntry
     {
         public final int id;
diff --git a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
index 14913b32c..41fd7caf2 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
@@ -88,14 +88,14 @@ public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
         {
             currentBurnTime--;
         }
-        if(worldObj != null && !worldObj.isClientSide)
+        if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj.getBlockId(x, y, z) == Blocks.FURNACE_BLAST_IDLE.id) {
+        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_BLAST_IDLE.id) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
             		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.NETHERRACK.id) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
-            			BlastFurnaceBlock.updateFurnaceBlockState(true, worldObj, x, y, z);
+            			updateFurnace();
             			furnaceUpdated = true;
             		}
             	}
@@ -143,7 +143,11 @@ public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
 
     @Override
     protected void updateFurnace(){
-        BlastFurnaceBlock.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
+        if (worldObj != null) {
+            BlastFurnaceBlock.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
+        } else if (carriedBlock != null) {
+            carriedBlock.block = currentBurnTime > 0 ? Blocks.FURNACE_BLAST_ACTIVE : Blocks.FURNACE_BLAST_IDLE;
+        }
     }
 
     private boolean canSmelt()
